;----------------------------------------------------------------------------
;    MODULE NAME:   QSORT.X
;
;        $Author:   Dennis_Bareis  $
;      $Revision:   1.3  $
;          $Date:   31 Jan 1999 17:40:54  $
;       $Logfile:   E:/DB/PVCS.IT/OS2/REXXHDR/QSORT.X_V  $
;         SOURCE:   http://www.labyrinth.net.au/~dbareis/index.htm (db0@anz.com)
;
;    DESCRIPTION:   Example program for "QSORT.XH".
;
;                   Compile with "ppwizard QSORT.X /rexx"
;----------------------------------------------------------------------------

/*
 * $Header:   E:/DB/PVCS.IT/OS2/REXXHDR/QSORT.X_V   1.3   31 Jan 1999 17:40:54   Dennis_Bareis  $
 */


/*--- Include SORT code for "normal sort" -----------------------------------*/
#define  QSORT_ROUTINE         ForwardsSort        ;;Use default "sort routine"
#define  QSORT_ARRAY           Numbers
#include "QSORT.XH"

/*--- Include SORT code for reverse sort ------------------------------------*/
#define  QSORT_ROUTINE         ReverseSort         ;;Name of function we will call
#define  QSORT_COMPARE_ROUTINE ReverseSortRoutine  ;;Name of routine we will supply
#define  QSORT_ARRAY           Numbers             ;;Name of the array to sort
#include "QSORT.XH"


/*--- Say the version of QSORT.XH being used --------------------------------*/
QsortHeader = 'Using QSORT.XH version <$HEADER_QSORT_XH>'
say QsortHeader;
say copies('~', length(QsortHeader));


/*--- Create an array (display it before sorting) ---------------------------*/
do Element = 1 to 9
   Numbers.Element = Element;
end;
Numbers.0 = 9;
call DisplayArray "Initial"


/*--- Sort numbers into reverse order and display ---------------------------*/
call ReverseSort;
call DisplayArray "Reversed"


/*--- Sort into numeric order and display -----------------------------------*/
call ForwardsSort;
call DisplayArray "Sorted"
exit(0);



/*===========================================================================*/
DisplayArray:
/*===========================================================================*/
   call charout ,right(arg(1), 12) || ': '
   do  Element = 1 to Numbers.0
       if  Element <> 1 then
           call charout ,', ';
       call charout ,Numbers.Element;
   end;
   say '';
   return;


/*===========================================================================*/
ReverseSortRoutine: PROCEDURE
/*===========================================================================*/
   parse arg a, b
   /*--- Do the compare -----------------------------------------------------*/
   select
       /*+++++++++++++++++++*/
       when ( a < b ) then
       /*+++++++++++++++++++*/
           return(1);                      ;; A > B (reversed remember!)
       /*+++++++++++++++++++*/
       when ( a > b ) then
       /*+++++++++++++++++++*/
           return(-1);                     ;; A < B (reversed remember!)
       /*+++++++++++++++++++*/
       otherwise
       /*+++++++++++++++++++*/
           return(0);
   end;
